VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Notepad - New File"
   ClientHeight    =   4065
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   7080
   Icon            =   "notepad.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4065
   ScaleWidth      =   7080
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog CommonDialog2 
      Left            =   240
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "txt"
      DialogTitle     =   "Open file"
      FileName        =   "*.txt"
      Filter          =   "Text files (*.txt)|*.txt|All Files (*.*)|*.*"
      MaxFileSize     =   256
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   1440
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DefaultExt      =   "txt"
      DialogTitle     =   "Save file"
      FileName        =   "*.txt"
      Filter          =   "Text File (*.txt)|*.txt"
      MaxFileSize     =   256
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4095
      Left            =   0
      MaxLength       =   50000
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   7080
   End
   Begin VB.Menu File 
      Caption         =   "&File"
      WindowList      =   -1  'True
      Begin VB.Menu New 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu Open 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu Save 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu SaveAs 
         Caption         =   "Save &As"
         Shortcut        =   ^A
      End
      Begin VB.Menu sep1 
         Caption         =   "-"
      End
      Begin VB.Menu Print 
         Caption         =   "&Print"
         Shortcut        =   ^P
      End
      Begin VB.Menu sep2 
         Caption         =   "-"
      End
      Begin VB.Menu Exit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu Edit 
      Caption         =   "&Edit"
      Begin VB.Menu Cut 
         Caption         =   "Cu&t"
         Shortcut        =   ^X
      End
      Begin VB.Menu Copy 
         Caption         =   "&Copy"
         Shortcut        =   ^C
      End
      Begin VB.Menu Paste 
         Caption         =   "&Paste"
         Shortcut        =   ^V
      End
      Begin VB.Menu Delete 
         Caption         =   "De&lete"
         Shortcut        =   ^D
      End
      Begin VB.Menu sep3 
         Caption         =   "-"
      End
      Begin VB.Menu SelectAll 
         Caption         =   "Select &All"
      End
   End
   Begin VB.Menu Help 
      Caption         =   "&Help"
      Begin VB.Menu About 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim filename As String  ' stores name of file currently in use.
Dim saved, response     ' saved indicates whether file has been saved or not.

Private Sub About_Click()   ' displays About form.
  frmAbout.Show
End Sub

Private Sub Copy_Click()         ' to copy text to clipboard.
  Clipboard.SetText Text1.SelText
End Sub

Private Sub Cut_Click()           ' to cut text from file.
  Clipboard.SetText Text1.SelText
  Text1.SelText = ""
End Sub

Private Sub Delete_Click()  ' to delete block of text from file.
  Text1.SelText = ""
End Sub

Private Sub Exit_Click()    ' exit program.
  Dim msg, style, title
  If (saved) Then          ' checks if file has been saved
    End                    ' only then does it exit.
' if file has not been saved, prompts user for saving.
   Else
    msg = "File " + filename + " not saved." + vbCrLf + vbCrLf + "Save it?"
    style = vbYesNoCancel + vbCritical + vbDefaultButton3
    title = "Notepad"
    response = MsgBox(msg, style, title)
    If (response = vbYes) Then
      Open filename For Output As #1
      Print #1, Text1.Text
      Close #1
      End
    End If
    If (response = vbNo) Then
      End
    End If
  End If
End Sub

Private Sub Form_Load() ' initialise variables.
  saved = True
  filename = ""
  CommonDialog2.Flags = cdlOFNFileMustExist   ' in Open dialog box, file to be opened must exist.
  CommonDialog1.Flags = cdlOFNOverwritePrompt ' in Save dialog box, it prompts for overwrite.
End Sub

Private Sub Form_Resize()   ' change size of text box corresponding to change in size of form.
   Text1.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub New_Click()    ' create new file.
  Dim msg, style, title
  If (saved) Then          ' check if previous file is saved.
    filename = ""          ' if saved, prepare for new one.
    Text1.Text = ""
    Form1.Caption = "Notepad - New File"
   Else
    msg = "File " + filename + " not saved." + vbCrLf + vbCrLf + "Save it?"
    style = vbYesNoCancel + vbCritical + vbDefaultButton3
    title = "Notepad"
    response = MsgBox(msg, style, title)
    If (response = vbYes) Then
      Save_Click
      If (saved = True) Then
        filename = ""
        Text1.Text = ""
        Form1.Caption = "Notepad - New File"
      End If
    End If
    If (response = vbNo) Then
      filename = ""
      Text1.Text = ""
      Form1.Caption = "Notepad - New File"
      saved = True
    End If
  End If
End Sub

Private Sub Open_Click()  ' open a file.
  Dim msg, style, title
  If (saved) Then          ' check if previous is saved.
    Open_File
   Else
    msg = "File " + filename + " not saved." + vbCrLf + vbCrLf + "Save it?"
    style = vbYesNoCancel + vbCritical + vbDefaultButton3
    title = "Notepad"
    response = MsgBox(msg, style, title)
    If (response = vbYes) Then
      Open filename For Output As #1
      Print #1, Text1.Text
      Close #1
      saved = True
      Open_File
    End If
    If (response = vbNo) Then
      Open_File
    End If
  End If
End Sub

Private Sub Paste_Click()   ' paste text into file.
  Text1.SelText = Clipboard.GetText
End Sub

Private Sub Print_Click()
  CommonDialog1.CancelError = True
  On Error GoTo errorhandler
  CommonDialog1.ShowPrinter
  Printer.FontName = "Courier New"
  Printer.FontSize = 12
  Printer.FontBold = True
  Printer.Print Text1.Text
  Printer.EndDoc
  Exit Sub
errorhandler:
  Exit Sub
End Sub

Private Sub Save_Click()    ' save a file.
  If (Len(filename) = 0) Then  ' if new file then bring up dialog box.
    CommonDialog1.ShowSave
    filename = CommonDialog1.filename
    If (filename = "*.txt") Then filename = ""
    If (Len(filename) <> 0) Then      ' was Cancel clicked?
      Open CommonDialog1.filename For Output As #1
      Print #1, Text1.Text
      Close #1
      saved = True
      Form1.Caption = "Notepad - " + filename
    End If
   Else        ' if not new file then just save.
    Open filename For Output As #1
    Print #1, Text1.Text
    Close #1
    saved = True
  End If
End Sub

Private Sub SaveAs_Click()   ' save file another name.
  CommonDialog1.ShowSave
  filename = CommonDialog1.filename
  If (filename = "*.txt") Then filename = ""
  If (Len(filename) <> 0) Then
    Open CommonDialog1.filename For Output As #1
    Print #1, Text1.Text
    Close #1
    saved = True
    Form1.Caption = "Notepad - " + filename
  End If
End Sub

Private Sub SelectAll_Click()   ' select entire text from file.
  Text1.SelStart = 0
  Text1.SelLength = Len(Text1.Text)
End Sub

Private Sub Text1_Change()
  saved = False     ' if file contents change, it is in unsaved state.
End Sub

Public Sub Open_File()         ' open a file.
  Dim temp, tempfile, temptext, filetext
  tempfile = filename   ' in case file is not opened(Cancel is clicked)
  temptext = Text1.Text ' we need to restore contents of textbox.
  CommonDialog2.ShowOpen
  filename = CommonDialog2.filename
  If (filename = "*.txt") Then filename = ""
  If (Len(filename) <> 0) Then          ' was Cancel clicked?
    If (FileLen(filename) < 50000) Then  ' very large file cannot be opened.
      Text1.Text = ""
      filetext = ""
      Open CommonDialog2.filename For Input As #1
      Do While Not EOF(1)
        Line Input #1, temp
        filetext = filetext + temp + vbCrLf
      Loop
      Form1.Caption = "Notepad - " + filename
      Text1.Text = filetext
      Close #1
      saved = True
     Else             ' file is too large to be opened.
      Display_Msg
      filename = ""
    End If
  End If
  If (Len(filename) = 0) Then  ' if no file opened restore contents.
    filename = temp
    Text1.Text = temptext
  End If
End Sub

Public Sub Display_Msg()  ' display 'file too large' message.
  Dim msg, style, title
  msg = "File is too large to be opened by Notepad!"
  style = vbOKOnly + vbDefaultButton1
  title = "Notepad"
  response = MsgBox(msg, style, title)
End Sub
